Move installer dir under packaging (#5009)

* move installer dir under packaging

* fix docs creation

* uninstaller is broken and fix will be created in #5031

* fix links in docs
This commit is contained in:
Paweł Krupa 2018-12-19 12:08:40 +01:00 committed by GitHub
parent f4fbf21363
commit 545aa97455
No known key found for this signature in database
GPG Key ID: 4AEE18F83AFDEB23
21 changed files with 339 additions and 339 deletions

View File

@ -78,9 +78,9 @@ dist_noinst_DATA= \
docs/Charts.md \
docs/configuration-guide.md \
docs/generator/custom \
installer/README.md \
installer/UNINSTALL.md \
installer/UPDATE.md \
packaging/installer/README.md \
packaging/installer/UNINSTALL.md \
packaging/installer/UPDATE.md \
netlify.toml \
$(NULL)
@ -91,7 +91,7 @@ dist_noinst_SCRIPTS= \
kickstart.sh \
kickstart-static64.sh \
netdata-installer.sh \
installer/functions.sh \
packaging/installer/functions.sh \
docs/generator/buildhtml.sh \
docs/generator/buildyaml.sh \
docs/generator/checklinks.sh \
@ -125,10 +125,10 @@ AM_CFLAGS = \
$(NULL)
sbin_PROGRAMS =
dist_cache_DATA = installer/.keep
dist_varlib_DATA = installer/.keep
dist_registry_DATA = installer/.keep
dist_log_DATA = installer/.keep
dist_cache_DATA = packaging/installer/.keep
dist_varlib_DATA = packaging/installer/.keep
dist_registry_DATA = packaging/installer/.keep
dist_log_DATA = packaging/installer/.keep
plugins_PROGRAMS =
LIBNETDATA_FILES = \

View File

@ -94,7 +94,7 @@ The above command will:
2. download netdata source to `/usr/src/netdata.git`
3. compile it, install it and start it
More installation methods and additional options can be found at the [installation page](installer/#installation).
More installation methods and additional options can be found at the [installation page](packaging/installer/#installation).
To try netdata in a docker container, run this:
@ -459,7 +459,7 @@ Here is a quick list:
Directory|Description
:---|:---
[`installer`](installer/)|Instructions to install netdata on your systems.
[`installer`](packaging/installer/)|Instructions to install netdata on your systems.
[`docker`](packaging/docker/)|Instructions to install netdata using docker.
[`daemon`](daemon/)|Information about the netdata daemon and its configuration.
[`collectors`](collectors/)|Information about data collection plugins.

View File

@ -67,7 +67,7 @@ chooses the base container images (centos:latest). After running this you should
be sitting inside the shell of the container.
After we have entered the shell we can install Netdata. This process could not
be easier. If you take a look at [this link](../installer/#installation), the Netdata devs give us
be easier. If you take a look at [this link](../packaging/installer/#installation), the Netdata devs give us
several one-liners to install netdata. I have not had any issues with these one
liners and their bootstrapping scripts so far (If you guys run into anything do
share). Run the following command in your container.

View File

@ -9,7 +9,7 @@ Prometheus is a distributed monitoring system which offers a very simple setup a
### Installing netdata
There are number of ways to install netdata according to [Installation](../../installer/#installation)
There are number of ways to install netdata according to [Installation](../../packaging/installer/#installation)
The suggested way of installing the latest netdata and keep it upgrade automatically. Using one line installation:
```

View File

@ -5,7 +5,7 @@
cd "$(dirname "$0")/../../" || exit 1
# shellcheck disable=SC1091
source "installer/functions.sh" || exit 1
source "packaging/installer/functions.sh" || exit 1
set -e

View File

@ -1,6 +1,6 @@
# Getting Started
These are your first steps **after** you have installed netdata. If you haven't installed it already, please check the [installation page](../installer).
These are your first steps **after** you have installed netdata. If you haven't installed it already, please check the [installation page](../packaging/installer).
## Accessing the dashboard
@ -14,11 +14,11 @@ http://your.server.ip:19999/
**Verify Netdata is running.**
Open an ssh session to the server and execute `sudo ps -e | grep netdata`. It should respond with the PID of the netdata daemon. If it prints nothing, Netdata is not running. Check the [installation page](../installer) to install it.
Open an ssh session to the server and execute `sudo ps -e | grep netdata`. It should respond with the PID of the netdata daemon. If it prints nothing, Netdata is not running. Check the [installation page](../packaging/installer) to install it.
**Verify Netdata responds to HTTP requests.**
Using the same ssh session, execute `curl -Ss http://localhost:19999`. It should dump on your screen the `index.html` page of the dashboard. If it does not, check the [installation page](../installer) to install it.
Using the same ssh session, execute `curl -Ss http://localhost:19999`. It should dump on your screen the `index.html` page of the dashboard. If it does not, check the [installation page](../packaging/installer) to install it.
**Verify Netdata receives the HTTP requests.**

View File

@ -125,10 +125,10 @@ echo -ne " - 'docs/Why-Netdata.md'
- CHANGELOG.md
- CONTRIBUTING.md
- Installation:
- 'installer/README.md'
- 'packaging/installer/README.md'
- 'packaging/docker/README.md'
- 'installer/UPDATE.md'
- 'installer/UNINSTALL.md'
- 'packaging/installer/UPDATE.md'
- 'packaging/installer/UNINSTALL.md'
- 'docs/GettingStarted.md'
- Running netdata:
- 'daemon/README.md'

View File

@ -9,7 +9,7 @@ umask 022
[ -z "${UID}" ] && export UID="$(id -u)"
# ---------------------------------------------------------------------------------------------------------------------
# library functions copied from installer/functions.sh
# library functions copied from packaging/installer/functions.sh
which_cmd() {
# shellcheck disable=SC2230

View File

@ -31,7 +31,7 @@ umask 022
[ -z "${UID}" ] && UID="$(id -u)"
# ---------------------------------------------------------------------------------------------------------------------
# library functions copied from installer/functions.sh
# library functions copied from packaging/installer/functions.sh
which_cmd() {
# shellcheck disable=SC2230

View File

@ -1,7 +1,7 @@
#!/usr/bin/env bash
# SPDX-License-Identifier: GPL-3.0-or-later
. $(dirname "$0")/../installer/functions.sh || exit 1
. $(dirname "$0")/../packaging/installer/functions.sh || exit 1
set -e

View File

@ -49,7 +49,7 @@ fetch() {
# -----------------------------------------------------------------------------
# load the functions of the netdata-installer.sh
. "${NETDATA_SOURCE_PATH}/installer/functions.sh"
. "${NETDATA_SOURCE_PATH}/packaging/installer/functions.sh"
# -----------------------------------------------------------------------------

View File

@ -45,7 +45,7 @@ run mkdir -p "${NETDATA_INSTALL_PATH}/system"
run cp \
makeself/post-installer.sh \
makeself/install-or-update.sh \
installer/functions.sh \
packaging/installer/functions.sh \
configs.signatures \
system/netdata-init-d \
system/netdata-lsb \

View File

@ -34,10 +34,10 @@ cd "${netdata_source_dir}" || exit 1
# -----------------------------------------------------------------------------
# load the required functions
if [ -f "${installer_dir}/installer/functions.sh" ]; then
source "${installer_dir}/installer/functions.sh" || exit 1
if [ -f "${installer_dir}/packaging/installer/functions.sh" ]; then
source "${installer_dir}/packaging/installer/functions.sh" || exit 1
else
source "${netdata_source_dir}/installer/functions.sh" || exit 1
source "${netdata_source_dir}/packaging/installer/functions.sh" || exit 1
fi
# make sure we save all commands we run
@ -885,7 +885,7 @@ fi
# -----------------------------------------------------------------------------
progress "Create netdata-uninstaller.sh"
cp ./installer/netdata-uninstaller.sh netdata-uninstaller.sh
cp ./packaging/installer/netdata-uninstaller.sh netdata-uninstaller.sh
chmod 750 netdata-uninstaller.sh
# -----------------------------------------------------------------------------
@ -911,7 +911,7 @@ END
echo >&2 "Uninstall script is located at: ${TPUT_RED}${TPUT_BOLD}./netdata-uninstaller.sh${TPUT_RESET}"
if [ -d .git ]; then
cp ./installer/netdata-updater.sh netdata-updater.sh
cp ./packaging/installer/netdata-updater.sh netdata-updater.sh
sed -i "s|THIS_SHOULD_BE_REPLACED_BY_INSTALLER_SCRIPT|${REINSTALL_PWD}|" netdata-updater.sh
chmod 755 netdata-updater.sh
echo >&2 "Update script is located at: ${TPUT_GREEN}${TPUT_BOLD}./netdata-updater.sh${TPUT_RESET}"
@ -956,7 +956,7 @@ else
fi
# Save environment variables
cat <<EOF > installer/.environment.sh
cat <<EOF > packaging/installer/.environment.sh
PATH="${PATH}"
CFLAGS="${CFLAGS}"
NETDATA_PREFIX="${NETDATA_PREFIX}"

View File

@ -17,7 +17,7 @@ The best way to install Netdata is directly from source. Our **automatic install
7. [Enable on FreeNAS Corral](#freenas)
8. [Install on macOS (OS X)](#macos)
See also the list of Netdata [package maintainers](../packaging/maintainers) for ASUSTOR NAS, OpenWRT, ReadyNAS, etc.
See also the list of Netdata [package maintainers](../maintainers) for ASUSTOR NAS, OpenWRT, ReadyNAS, etc.
---
@ -31,7 +31,7 @@ To install Netdata from source and keep it up to date automatically, run the fol
bash <(curl -Ss https://my-netdata.io/kickstart.sh)
```
*(do not `sudo` this command, it will do it by itself as needed)*
*(do not `sudo` this command, it will do it by itself as needed)*
![](https://registry.my-netdata.io/api/v1/badge.svg?chart=web_log_nginx.requests_per_url&options=unaligned&dimensions=kickstart&group=sum&after=-3600&label=last+hour&units=installations&value_color=orange&precision=0) ![](https://registry.my-netdata.io/api/v1/badge.svg?chart=web_log_nginx.requests_per_url&options=unaligned&dimensions=kickstart&group=sum&after=-86400&label=today&units=installations&precision=0)
@ -47,43 +47,43 @@ Verify the integrity of the script with this:
The `kickstart.sh` script:
- detects the Linux distro and **installs the required system packages** for building Netdata (will ask for confirmation)
- downloads the latest Netdata source tree to `/usr/src/netdata.git`.
- installs Netdata by running `./netdata-installer.sh` from the source tree.
- detects the Linux distro and **installs the required system packages** for building Netdata (will ask for confirmation)
- downloads the latest Netdata source tree to `/usr/src/netdata.git`.
- installs Netdata by running `./netdata-installer.sh` from the source tree.
- installs `netdata-updater.sh` to `cron.daily`, so your Netdata installation will be updated daily (you will get a message from cron only if the update fails).
- For QA purposes, this installation method lets us know if it succeed or failed.
The `kickstart.sh` script passes all its parameters to `netdata-installer.sh`, so you can add more parameters to change the installation directory, enable/disable plugins, etc (check below).
The `kickstart.sh` script passes all its parameters to `netdata-installer.sh`, so you can add more parameters to change the installation directory, enable/disable plugins, etc (check below).
For automated installs, append a space + `--dont-wait` to the command line. You can also append `--dont-start-it` to prevent the installer from starting Netdata. Example:
```bash
bash <(curl -Ss https://my-netdata.io/kickstart.sh) --dont-wait --dont-start-it
```
</details>&nbsp;<br/>
Once Netdata is installed, see [Getting Started](../docs/GettingStarted.md).
Once Netdata is installed, see [Getting Started](../../docs/GettingStarted.md).
---
## Linux 64bit pre-built static binary
You can install a pre-compiled static binary of Netdata on any Intel/AMD 64bit Linux system
(even those that don't have a package manager, like CoreOS, CirrOS, busybox systems, etc).
You can install a pre-compiled static binary of Netdata on any Intel/AMD 64bit Linux system
(even those that don't have a package manager, like CoreOS, CirrOS, busybox systems, etc).
You can also use these packages on systems with broken or unsupported package managers.
To install Netdata with a binary package on any Linux distro, any kernel version - for **Intel/AMD 64bit** hosts, run the following:
```bash
bash <(curl -Ss https://my-netdata.io/kickstart-static64.sh)
bash <(curl -Ss https://my-netdata.io/kickstart-static64.sh)
```
*(do not `sudo` this command, it will do it by itself as needed; if the target system does not have `bash` installed, see below for instructions to run it without `bash`)*
![](https://registry.my-netdata.io/api/v1/badge.svg?chart=web_log_nginx.requests_per_url&options=unaligned&dimensions=kickstart64&group=sum&after=-3600&label=last+hour&units=installations&value_color=orange&precision=0) ![](https://registry.my-netdata.io/api/v1/badge.svg?chart=web_log_nginx.requests_per_url&options=unaligned&dimensions=kickstart64&group=sum&after=-86400&label=today&units=installations&precision=0)
![](https://registry.my-netdata.io/api/v1/badge.svg?chart=web_log_nginx.requests_per_url&options=unaligned&dimensions=kickstart64&group=sum&after=-3600&label=last+hour&units=installations&value_color=orange&precision=0) ![](https://registry.my-netdata.io/api/v1/badge.svg?chart=web_log_nginx.requests_per_url&options=unaligned&dimensions=kickstart64&group=sum&after=-86400&label=today&units=installations&precision=0)
> The static builds install Netdata at **`/opt/netdata`**
@ -98,27 +98,27 @@ Verify the integrity of the script with this:
*It should print `OK, VALID` if the script is the one we ship.*
For automated installs, append a space + `--dont-wait` to the command line. You can also append `--dont-start-it` to prevent the installer from starting Netdata.
Example:
For automated installs, append a space + `--dont-wait` to the command line. You can also append `--dont-start-it` to prevent the installer from starting Netdata.
Example:
```bash
bash <(curl -Ss https://my-netdata.io/kickstart-static64.sh) --dont-wait --dont-start-it
bash <(curl -Ss https://my-netdata.io/kickstart-static64.sh) --dont-wait --dont-start-it
```
If your shell fails to handle the above one liner, do this:
If your shell fails to handle the above one liner, do this:
```bash
# download the script with curl
curl https://my-netdata.io/kickstart-static64.sh >/tmp/kickstart-static64.sh
# or, download the script with wget
wget -O /tmp/kickstart-static64.sh https://my-netdata.io/kickstart-static64.sh
# run the downloaded script (any sh is fine, no need for bash)
sh /tmp/kickstart-static64.sh
# download the script with curl
curl https://my-netdata.io/kickstart-static64.sh >/tmp/kickstart-static64.sh
# or, download the script with wget
wget -O /tmp/kickstart-static64.sh https://my-netdata.io/kickstart-static64.sh
# run the downloaded script (any sh is fine, no need for bash)
sh /tmp/kickstart-static64.sh
```
- The static binary files are kept in repo [binary-packages](https://github.com/netdata/binary-packages). You can download any of the `.run` files, and run it. These files are self-extracting shell scripts built with [makeself](https://github.com/megastep/makeself).
@ -128,284 +128,284 @@ sh /tmp/kickstart-static64.sh
</details>&nbsp;<br/>
Once Netdata is installed, see [Getting Started](../docs/GettingStarted.md).
Once Netdata is installed, see [Getting Started](../../docs/GettingStarted.md).
---
## Run Netdata in a Docker container
You can [Install Netdata with Docker](../packaging/docker/#install-netdata-with-docker).
You can [Install Netdata with Docker](../docker/#install-netdata-with-docker).
---
## Install Netdata on Linux manually
To install the latest git version of Netdata, please follow these 2 steps:
1. [Prepare your system](#prepare-your-system)
Install the required packages on your system.
2. [Install Netdata](#install-netdata)
Download and install Netdata. You can also update it the same way.
---
### Prepare your system
Try our experimental automatic requirements installer (no need to be root). This will try to find the packages that should be installed on your system to build and run Netdata. It supports most major Linux distributions released after 2010:
- **Alpine** Linux and its derivatives (you have to install `bash` yourself, before using the installer)
- **Arch** Linux and its derivatives
- **Gentoo** Linux and its derivatives
- **Debian** Linux and its derivatives (including **Ubuntu**, **Mint**)
- **Fedora** and its derivatives (including **Red Hat Enterprise Linux**, **CentOS**, **Amazon Machine Image**)
- **SuSe** Linux and its derivatives (including **openSuSe**)
- **SLE12** Must have your system registered with Suse Customer Center or have the DVD. See [#1162](https://github.com/netdata/netdata/issues/1162)
Install the packages for having a **basic Netdata installation** (system monitoring and many applications, without `mysql` / `mariadb`, `postgres`, `named`, hardware sensors and `SNMP`):
```sh
curl -Ss 'https://raw.githubusercontent.com/netdata/netdata-demo-site/master/install-required-packages.sh' >/tmp/kickstart.sh && bash /tmp/kickstart.sh -i netdata
```
Install all the required packages for **monitoring everything Netdata can monitor**:
```sh
curl -Ss 'https://raw.githubusercontent.com/netdata/netdata-demo-site/master/install-required-packages.sh' >/tmp/kickstart.sh && bash /tmp/kickstart.sh -i netdata-all
```
If the above do not work for you, please [open a github issue](https://github.com/netdata/netdata/issues/new?title=packages%20installer%20failed&labels=installation%20help&body=The%20experimental%20packages%20installer%20failed.%0A%0AThis%20is%20what%20it%20says:%0A%0A%60%60%60txt%0A%0Aplease%20paste%20your%20screen%20here%0A%0A%60%60%60) with a copy of the message you get on screen. We are trying to make it work everywhere (this is also why the script [reports back](https://github.com/netdata/netdata/issues/2054) success or failure for all its runs).
---
This is how to do it by hand:
```sh
# Debian / Ubuntu
apt-get install zlib1g-dev uuid-dev libmnl-dev gcc make git autoconf autoconf-archive autogen automake pkg-config curl
# Fedora
dnf install zlib-devel libuuid-devel libmnl-devel gcc make git autoconf autoconf-archive autogen automake pkgconfig curl findutils
# CentOS / Red Hat Enterprise Linux
yum install autoconf automake curl gcc git libmnl-devel libuuid-devel lm_sensors make MySQL-python nc pkgconfig python python-psycopg2 PyYAML zlib-devel
```
Please note that for RHEL/CentOS you might need [EPEL](http://www.tecmint.com/how-to-enable-epel-repository-for-rhel-centos-6-5/).
Once Netdata is compiled, to run it the following packages are required (already installed using the above commands):
package|description
:-----:|-----------
`libuuid`|part of `util-linux` for GUIDs management
`zlib`|gzip compression for the internal Netdata web server
*Netdata will fail to start without the above.*
Netdata plugins and various aspects of Netdata can be enabled or benefit when these are installed (they are optional):
package|description
:-----:|-----------
`bash`|for shell plugins and **alarm notifications**
`curl`|for shell plugins and **alarm notifications**
`iproute` or `iproute2`|for monitoring **Linux traffic QoS**<br/>use `iproute2` if `iproute` reports as not available or obsolete
`python`|for most of the external plugins
`python-yaml`|used for monitoring **beanstalkd**
`python-beanstalkc`|used for monitoring **beanstalkd**
`python-dnspython`|used for monitoring DNS query time
`python-ipaddress`|used for monitoring **DHCPd**<br/>this package is required only if the system has python v2. python v3 has this functionality embedded
`python-mysqldb`<br/>or<br/>`python-pymysql`|used for monitoring **mysql** or **mariadb** databases<br/>`python-mysqldb` is a lot faster and thus preferred
`python-psycopg2`|used for monitoring **postgresql** databases
`python-pymongo`|used for monitoring **mongodb** databases
`nodejs`|used for `node.js` plugins for monitoring **named** and **SNMP** devices
`lm-sensors`|for monitoring **hardware sensors**
`libmnl`|for collecting netfilter metrics
`netcat`|for shell plugins to collect metrics from remote systems
*Netdata will greatly benefit if you have the above packages installed, but it will still work without them.*
---
### Install Netdata
Do this to install and run Netdata:
```sh
# download it - the directory 'netdata' will be created
git clone https://github.com/netdata/netdata.git --depth=1
cd netdata
# run script with root privileges to build, install, start Netdata
./netdata-installer.sh
```
* If you don't want to run it straight-away, add `--dont-start-it` option.
* If you don't want to install it on the default directories, you can run the installer like this: `./netdata-installer.sh --install /opt`. This one will install Netdata in `/opt/netdata`.
Once the installer completes, the file `/etc/netdata/netdata.conf` will be created (if you changed the installation directory, the configuration will appear in that directory too).
You can edit this file to set options. One common option to tweak is `history`, which controls the size of the memory database Netdata will use. By default is `3600` seconds (an hour of data at the charts) which makes Netdata use about 10-15MB of RAM (depending on the number of charts detected on your system). Check **[[Memory Requirements]]**.
To apply the changes you made, you have to restart Netdata.
---
## Other Systems
##### FreeBSD
You can install Netdata from ports or packages collection.
This is how to install the latest Netdata version from sources on FreeBSD:
```sh
# install required packages
pkg install bash e2fsprogs-libuuid git curl autoconf automake pkgconf pidof
# download Netdata
git clone https://github.com/netdata/netdata.git --depth=1
# install Netdata in /opt/netdata
cd netdata
./netdata-installer.sh --install /opt
```
##### pfSense
To install Netdata on pfSense run the following commands (within a shell or under Diagnostics/Command Prompt within the pfSense web interface).
Change platform (i386/amd64, etc) and FreeBSD versions (10/11, etc) according to your environment and change Netdata version (1.10.0 in example) according to latest version present within the FreeSBD repository:-
Note first three packages are downloaded from the pfSense repository for maintaining compatibility with pfSense, Netdata is downloaded from the FreeBSD repository.
```
pkg install pkgconf
pkg install bash
pkg install e2fsprogs-libuuid
pkg add http://pkg.freebsd.org/FreeBSD:11:amd64/latest/All/netdata-1.11.0.txz
```
To start Netdata manually run `service netdata onestart`
To start Netdata automatically at each boot add `service netdata start` as a Shellcmd within the pfSense web interface (under **Services/Shellcmd**, which you need to install beforehand under **System/Package Manager/Available Packages**).
Shellcmd Type should be set to `Shellcmd`.
![](https://user-images.githubusercontent.com/36808164/36930790-4db3aa84-1f0d-11e8-8752-cdc08bb7207c.png)
Alternatively more information can be found in https://doc.pfsense.org/index.php/Installing_FreeBSD_Packages, for achieving the same via the command line and scripts.
If you experience an issue with `/usr/bin/install` absense on pfSense 2.3 or earlier, update pfSense or use workaround from [https://redmine.pfsense.org/issues/6643](https://redmine.pfsense.org/issues/6643)
##### FreeNAS
On FreeNAS-Corral-RELEASE (>=10.0.3), Netdata is pre-installed.
To use Netdata, the service will need to be enabled and started from the FreeNAS **[CLI](https://github.com/freenas/cli)**.
To enable the Netdata service:
```
service netdata config set enable=true
```
To start the netdata service:
```
service netdata start
```
##### macOS
Netdata on macOS still has limited charts, but external plugins do work.
You can either install Netdata with [Homebrew](https://brew.sh/)
```sh
brew install netdata
```
or from source:
```sh
# install Xcode Command Line Tools
xcode-select --install
```
click `Install` in the software update popup window, then
```sh
# install HomeBrew package manager
/usr/bin/ruby -e "$(curl -fsSL https://raw.githubusercontent.com/Homebrew/install/master/install)"
# install required packages
brew install ossp-uuid autoconf automake pkg-config
# download Netdata
git clone https://github.com/netdata/netdata.git --depth=1
# install Netdata in /usr/local/netdata
cd netdata
sudo ./netdata-installer.sh --install /usr/local
```
The installer will also install a startup plist to start Netdata when your Mac boots.
##### Alpine 3.x
Execute these commands to install Netdata in Alpine Linux 3.x:
```
# install required packages
apk add alpine-sdk bash curl zlib-dev util-linux-dev libmnl-dev gcc make git autoconf automake pkgconfig python logrotate
# if you plan to run node.js Netdata plugins
apk add nodejs
# download Netdata - the directory 'netdata' will be created
git clone https://github.com/netdata/netdata.git --depth=1
cd netdata
# build it, install it, start it
./netdata-installer.sh
# make Netdata start at boot
echo -e "#!/usr/bin/env bash\n/usr/sbin/netdata" >/etc/local.d/netdata.start
chmod 755 /etc/local.d/netdata.start
# make Netdata stop at shutdown
echo -e "#!/usr/bin/env bash\nkillall netdata" >/etc/local.d/netdata.stop
chmod 755 /etc/local.d/netdata.stop
# enable the local service to start automatically
rc-update add local
```
##### Synology
The documentation previously recommended installing the Debian Chroot package from the Synology community package sources and then running Netdata from within the chroot. This does not work, as the chroot environment does not have access to `/proc`, and therefore exposes very few metrics to Netdata. Additionally, [this issue](https://github.com/SynoCommunity/spksrc/issues/2758), still open as of 2018/06/24, indicates that the Debian Chroot package is not suitable for DSM versions greater than version 5 and may corrupt system libraries and render the NAS unable to boot.
The good news is that the 64-bit static installer works fine if your NAS is one that uses the amd64 architecture. It will install the content into `/opt/netdata`, making future removal safe and simple.
When Netdata is first installed, it will run as _root_. This may or may not be acceptable for you, and since other installations run it as the _netdata_ user, you might wish to do the same. This requires some extra work:
1. Creat a group `netdata` via the Synology group interface. Give it no access to anything.
2. Create a user `netdata` via the Synology user interface. Give it no access to anything and a random password. Assign the user to the `netdata` group. Netdata will chuid to this user when running.
3. Change ownership of the following directories, as defined in [Netdata Security](../docs/netdata-security.md#security-design):
```
$ chown -R root:netdata /opt/netdata/usr/share/netdata
$ chown -R netdata:netdata /opt/netdata/var/lib/netdata /opt/netdata/var/cache/netdata
$ chown -R netdata:root /opt/netdata/var/log/netdata
```
Additionally, as of 2018/06/24, the Netdata installer doesn't recognize DSM as an operating system, so no init script is installed. You'll have to do this manually:
1. Add [this file](https://gist.github.com/oskapt/055d474d7bfef32c49469c1b53e8225f) as `/etc/rc.netdata`. Make it executable with `chmod 0755 /etc/rc.netdata`.
2. Edit `/etc/rc.local` and add a line calling `/etc/rc.netdata` to have it start on boot:
```
# Netdata startup
[ -x /etc/rc.netdata ] && /etc/rc.netdata start
## Install Netdata on Linux manually
To install the latest git version of Netdata, please follow these 2 steps:
1. [Prepare your system](#prepare-your-system)
Install the required packages on your system.
2. [Install Netdata](#install-netdata)
Download and install Netdata. You can also update it the same way.
---
### Prepare your system
Try our experimental automatic requirements installer (no need to be root). This will try to find the packages that should be installed on your system to build and run Netdata. It supports most major Linux distributions released after 2010:
- **Alpine** Linux and its derivatives (you have to install `bash` yourself, before using the installer)
- **Arch** Linux and its derivatives
- **Gentoo** Linux and its derivatives
- **Debian** Linux and its derivatives (including **Ubuntu**, **Mint**)
- **Fedora** and its derivatives (including **Red Hat Enterprise Linux**, **CentOS**, **Amazon Machine Image**)
- **SuSe** Linux and its derivatives (including **openSuSe**)
- **SLE12** Must have your system registered with Suse Customer Center or have the DVD. See [#1162](https://github.com/netdata/netdata/issues/1162)
Install the packages for having a **basic Netdata installation** (system monitoring and many applications, without `mysql` / `mariadb`, `postgres`, `named`, hardware sensors and `SNMP`):
```sh
curl -Ss 'https://raw.githubusercontent.com/netdata/netdata-demo-site/master/install-required-packages.sh' >/tmp/kickstart.sh && bash /tmp/kickstart.sh -i netdata
```
Install all the required packages for **monitoring everything Netdata can monitor**:
```sh
curl -Ss 'https://raw.githubusercontent.com/netdata/netdata-demo-site/master/install-required-packages.sh' >/tmp/kickstart.sh && bash /tmp/kickstart.sh -i netdata-all
```
If the above do not work for you, please [open a github issue](https://github.com/netdata/netdata/issues/new?title=packages%20installer%20failed&labels=installation%20help&body=The%20experimental%20packages%20installer%20failed.%0A%0AThis%20is%20what%20it%20says:%0A%0A%60%60%60txt%0A%0Aplease%20paste%20your%20screen%20here%0A%0A%60%60%60) with a copy of the message you get on screen. We are trying to make it work everywhere (this is also why the script [reports back](https://github.com/netdata/netdata/issues/2054) success or failure for all its runs).
---
This is how to do it by hand:
```sh
# Debian / Ubuntu
apt-get install zlib1g-dev uuid-dev libmnl-dev gcc make git autoconf autoconf-archive autogen automake pkg-config curl
# Fedora
dnf install zlib-devel libuuid-devel libmnl-devel gcc make git autoconf autoconf-archive autogen automake pkgconfig curl findutils
# CentOS / Red Hat Enterprise Linux
yum install autoconf automake curl gcc git libmnl-devel libuuid-devel lm_sensors make MySQL-python nc pkgconfig python python-psycopg2 PyYAML zlib-devel
```
Please note that for RHEL/CentOS you might need [EPEL](http://www.tecmint.com/how-to-enable-epel-repository-for-rhel-centos-6-5/).
Once Netdata is compiled, to run it the following packages are required (already installed using the above commands):
package|description
:-----:|-----------
`libuuid`|part of `util-linux` for GUIDs management
`zlib`|gzip compression for the internal Netdata web server
*Netdata will fail to start without the above.*
Netdata plugins and various aspects of Netdata can be enabled or benefit when these are installed (they are optional):
package|description
:-----:|-----------
`bash`|for shell plugins and **alarm notifications**
`curl`|for shell plugins and **alarm notifications**
`iproute` or `iproute2`|for monitoring **Linux traffic QoS**<br/>use `iproute2` if `iproute` reports as not available or obsolete
`python`|for most of the external plugins
`python-yaml`|used for monitoring **beanstalkd**
`python-beanstalkc`|used for monitoring **beanstalkd**
`python-dnspython`|used for monitoring DNS query time
`python-ipaddress`|used for monitoring **DHCPd**<br/>this package is required only if the system has python v2. python v3 has this functionality embedded
`python-mysqldb`<br/>or<br/>`python-pymysql`|used for monitoring **mysql** or **mariadb** databases<br/>`python-mysqldb` is a lot faster and thus preferred
`python-psycopg2`|used for monitoring **postgresql** databases
`python-pymongo`|used for monitoring **mongodb** databases
`nodejs`|used for `node.js` plugins for monitoring **named** and **SNMP** devices
`lm-sensors`|for monitoring **hardware sensors**
`libmnl`|for collecting netfilter metrics
`netcat`|for shell plugins to collect metrics from remote systems
*Netdata will greatly benefit if you have the above packages installed, but it will still work without them.*
---
### Install Netdata
Do this to install and run Netdata:
```sh
# download it - the directory 'netdata' will be created
git clone https://github.com/netdata/netdata.git --depth=1
cd netdata
# run script with root privileges to build, install, start Netdata
./netdata-installer.sh
```
* If you don't want to run it straight-away, add `--dont-start-it` option.
* If you don't want to install it on the default directories, you can run the installer like this: `./netdata-installer.sh --install /opt`. This one will install Netdata in `/opt/netdata`.
Once the installer completes, the file `/etc/netdata/netdata.conf` will be created (if you changed the installation directory, the configuration will appear in that directory too).
You can edit this file to set options. One common option to tweak is `history`, which controls the size of the memory database Netdata will use. By default is `3600` seconds (an hour of data at the charts) which makes Netdata use about 10-15MB of RAM (depending on the number of charts detected on your system). Check **[[Memory Requirements]]**.
To apply the changes you made, you have to restart Netdata.
---
## Other Systems
##### FreeBSD
You can install Netdata from ports or packages collection.
This is how to install the latest Netdata version from sources on FreeBSD:
```sh
# install required packages
pkg install bash e2fsprogs-libuuid git curl autoconf automake pkgconf pidof
# download Netdata
git clone https://github.com/netdata/netdata.git --depth=1
# install Netdata in /opt/netdata
cd netdata
./netdata-installer.sh --install /opt
```
##### pfSense
To install Netdata on pfSense run the following commands (within a shell or under Diagnostics/Command Prompt within the pfSense web interface).
Change platform (i386/amd64, etc) and FreeBSD versions (10/11, etc) according to your environment and change Netdata version (1.10.0 in example) according to latest version present within the FreeSBD repository:-
Note first three packages are downloaded from the pfSense repository for maintaining compatibility with pfSense, Netdata is downloaded from the FreeBSD repository.
```
pkg install pkgconf
pkg install bash
pkg install e2fsprogs-libuuid
pkg add http://pkg.freebsd.org/FreeBSD:11:amd64/latest/All/netdata-1.11.0.txz
```
To start Netdata manually run `service netdata onestart`
To start Netdata automatically at each boot add `service netdata start` as a Shellcmd within the pfSense web interface (under **Services/Shellcmd**, which you need to install beforehand under **System/Package Manager/Available Packages**).
Shellcmd Type should be set to `Shellcmd`.
![](https://user-images.githubusercontent.com/36808164/36930790-4db3aa84-1f0d-11e8-8752-cdc08bb7207c.png)
Alternatively more information can be found in https://doc.pfsense.org/index.php/Installing_FreeBSD_Packages, for achieving the same via the command line and scripts.
If you experience an issue with `/usr/bin/install` absense on pfSense 2.3 or earlier, update pfSense or use workaround from [https://redmine.pfsense.org/issues/6643](https://redmine.pfsense.org/issues/6643)
##### FreeNAS
On FreeNAS-Corral-RELEASE (>=10.0.3), Netdata is pre-installed.
To use Netdata, the service will need to be enabled and started from the FreeNAS **[CLI](https://github.com/freenas/cli)**.
To enable the Netdata service:
```
service netdata config set enable=true
```
To start the netdata service:
```
service netdata start
```
##### macOS
Netdata on macOS still has limited charts, but external plugins do work.
You can either install Netdata with [Homebrew](https://brew.sh/)
```sh
brew install netdata
```
or from source:
```sh
# install Xcode Command Line Tools
xcode-select --install
```
click `Install` in the software update popup window, then
```sh
# install HomeBrew package manager
/usr/bin/ruby -e "$(curl -fsSL https://raw.githubusercontent.com/Homebrew/install/master/install)"
# install required packages
brew install ossp-uuid autoconf automake pkg-config
# download Netdata
git clone https://github.com/netdata/netdata.git --depth=1
# install Netdata in /usr/local/netdata
cd netdata
sudo ./netdata-installer.sh --install /usr/local
```
The installer will also install a startup plist to start Netdata when your Mac boots.
##### Alpine 3.x
Execute these commands to install Netdata in Alpine Linux 3.x:
```
# install required packages
apk add alpine-sdk bash curl zlib-dev util-linux-dev libmnl-dev gcc make git autoconf automake pkgconfig python logrotate
# if you plan to run node.js Netdata plugins
apk add nodejs
# download Netdata - the directory 'netdata' will be created
git clone https://github.com/netdata/netdata.git --depth=1
cd netdata
# build it, install it, start it
./netdata-installer.sh
# make Netdata start at boot
echo -e "#!/usr/bin/env bash\n/usr/sbin/netdata" >/etc/local.d/netdata.start
chmod 755 /etc/local.d/netdata.start
# make Netdata stop at shutdown
echo -e "#!/usr/bin/env bash\nkillall netdata" >/etc/local.d/netdata.stop
chmod 755 /etc/local.d/netdata.stop
# enable the local service to start automatically
rc-update add local
```
##### Synology
The documentation previously recommended installing the Debian Chroot package from the Synology community package sources and then running Netdata from within the chroot. This does not work, as the chroot environment does not have access to `/proc`, and therefore exposes very few metrics to Netdata. Additionally, [this issue](https://github.com/SynoCommunity/spksrc/issues/2758), still open as of 2018/06/24, indicates that the Debian Chroot package is not suitable for DSM versions greater than version 5 and may corrupt system libraries and render the NAS unable to boot.
The good news is that the 64-bit static installer works fine if your NAS is one that uses the amd64 architecture. It will install the content into `/opt/netdata`, making future removal safe and simple.
When Netdata is first installed, it will run as _root_. This may or may not be acceptable for you, and since other installations run it as the _netdata_ user, you might wish to do the same. This requires some extra work:
1. Creat a group `netdata` via the Synology group interface. Give it no access to anything.
2. Create a user `netdata` via the Synology user interface. Give it no access to anything and a random password. Assign the user to the `netdata` group. Netdata will chuid to this user when running.
3. Change ownership of the following directories, as defined in [Netdata Security](../../docs/netdata-security.md#security-design):
```
$ chown -R root:netdata /opt/netdata/usr/share/netdata
$ chown -R netdata:netdata /opt/netdata/var/lib/netdata /opt/netdata/var/cache/netdata
$ chown -R netdata:root /opt/netdata/var/log/netdata
```
Additionally, as of 2018/06/24, the Netdata installer doesn't recognize DSM as an operating system, so no init script is installed. You'll have to do this manually:
1. Add [this file](https://gist.github.com/oskapt/055d474d7bfef32c49469c1b53e8225f) as `/etc/rc.netdata`. Make it executable with `chmod 0755 /etc/rc.netdata`.
2. Edit `/etc/rc.local` and add a line calling `/etc/rc.netdata` to have it start on boot:
```
# Netdata startup
[ -x /etc/rc.netdata ] && /etc/rc.netdata start
```
[![analytics](https://www.google-analytics.com/collect?v=1&aip=1&t=pageview&_s=1&ds=github&dr=https%3A%2F%2Fgithub.com%2Fnetdata%2Fnetdata&dl=https%3A%2F%2Fmy-netdata.io%2Fgithub%2Finstaller%2FREADME&_u=MAC~&cid=5792dfd7-8dc4-476b-af31-da2fdb9f93d2&tid=UA-64295674-3)]()

View File

@ -11,7 +11,7 @@ The update procedure depends on how you installed it:
### Manual update
The installer `netdata-installer.sh` generates a `netdata-updater.sh` script in the directory you downloaded netdata.
The installer `netdata-installer.sh` generates a `netdata-updater.sh` script in the directory you downloaded netdata.
You can use this script to update your netdata installation with the same options you used to install it in the first place.
Just run it and it will download and install the latest version of netdata. The same script can be put in a cronjob to update your netdata at regular intervals.
@ -46,7 +46,7 @@ Keep in mind, netdata may now have new features, or certain old features may now
_Please, consider the risks of running an auto-update. Something can always go wrong. Keep an eye on your installation, and run a manual update if something ever fails._
You can call `netdata-updater.sh` from a cron-job. A successful update will not trigger an email from cron.
You can call `netdata-updater.sh` from a cron-job. A successful update will not trigger an email from cron.
```sh
# Edit your cron-jobs

View File

@ -47,9 +47,9 @@ if [ "$YES" != "1" ]; then
fi
#shellcheck source=/dev/null
source installer/.environment.sh || exit 1
source packaging/installer/.environment.sh || exit 1
#shellcheck source=/dev/null
source installer/functions.sh || exit 1
source packaging/installer/functions.sh || exit 1
echo >&2 "Stopping a possibly running netdata..."
for p in $(stop_all_netdata netdata); do run kill "$p"; done

View File

@ -17,7 +17,7 @@ REINSTALL_PWD="THIS_SHOULD_BE_REPLACED_BY_INSTALLER_SCRIPT"
cd "${REINSTALL_PWD}" || exit 1
#shellcheck source=/dev/null
source installer/.environment.sh || exit 1
source packaging/installer/.environment.sh || exit 1
if [ "${INSTALL_UID}" != "$(id -u)" ]
then
@ -94,7 +94,7 @@ update() {
fi
popmsg="$(git stash pop 2>&1)"
if [ $? -eq 0 ] ; then
if [ $? -eq 0 ] ; then
info "Stashing local git changes. You can use ${popmsg} to reapply your changes."
fi

View File

@ -29,6 +29,6 @@ git status
echo "========= UPDATE ========="
./netdata-updater.sh
echo "========= UNINSTALL ========="
mv /tmp/netdata-uninstaller.sh ./netdata-uninstaller.sh
./netdata-uninstaller.sh --yes --force
#echo "========= UNINSTALL ========="
#mv /tmp/netdata-uninstaller.sh ./netdata-uninstaller.sh
#./netdata-uninstaller.sh --yes --force